source: trunk/MagicSoft/Mars/datacenter/scripts/copyscript@ 7476

Last change on this file since 7476 was 7476, checked in by Daniela Dorner, 19 years ago
*** empty log message ***
  • Property svn:executable set to *
File size: 11.2 KB
Line 
1#!/bin/sh
2#
3# ========================================================================
4#
5# *
6# * This file is part of MARS, the MAGIC Analysis and Reconstruction
7# * Software. It is distributed to you in the hope that it can be a useful
8# * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
9# * It is distributed WITHOUT ANY WARRANTY.
10# *
11# * Permission to use, copy, modify and distribute this software and its
12# * documentation for any purpose is hereby granted without fee,
13# * provided that the above copyright notice appear in all copies and
14# * that both that copyright notice and this permission notice appear
15# * in supporting documentation. It is provided "as is" without express
16# * or implied warranty.
17# *
18#
19#
20# Author(s): Daniela Dorner 08/2004 <mailto:dorner@astro.uni-wuerzburg.de>
21#
22# Copyright: MAGIC Software Development, 2000-2006
23#
24#
25# ========================================================================
26#
27#
28# This script handles the subsystem logfiles, which are copied every
29# day automatically from /local/ on pc15 in La Palma to
30# /home/lapalma/transfer/ on coma in the datacenter in Wuerzburg
31# The structure in this directory is: subsystem/date/logfile.*
32# The logfiles are from CC (*.rep, CC*.dbg, CC*.rbk, CC*.rep, CC*.run,
33# CC*.run.html), Cosy (cosy*.log, cosy*.rep, tpoint*.txt/starg*.txt)
34# AMC (AMC*.log, AMC*.info, AMC*.lut) and CaCo (dc*.txt)
35#
36# the script performs the following steps:
37# ----------------------------------------
38# - filling the information from the *.rbk and *.run files into the DB
39# using the macros filldotrbk.C and filldotrun.C
40# - copying all logfiles to the correct directory:
41# /subsystemdata/subsystem/YYYY/MM/DD/file.*
42# - building the sequences for the standard analysis in the database
43# (for each day of which a file was copied)
44# - if a new catalogfile has been copied, it is installed as standard in the
45# setup directory /magic/datacenter/setup and the new lines are sent to
46# the adresses specified in the script
47#
48# -- to make sure that no file is copied twice there's a textfile
49# (.processed), to which every file, that was processed, is added
50# .processed is copied to La Palma, so that it is possible to copy
51# only new files
52# -- to make sure that a file was copied completely before it is
53# processed, a file with the checksum of all files is also copied from
54# La Palma and the checksum is checked with this script for each file
55# before processing it.
56#
57#
58
59user=`whoami`
60source /home/$user/Mars/datacenter/scripts/sourcefile
61
62set -C
63
64umask 0002
65
66transdir=/home/lapalma/transfer
67char=28
68datetime=`date +%F-%H-%M-%S`
69lockfile=$lockpath/lock-copyscript.txt
70
71scriptlogpath=$logpath/run/copyscript/`date +%Y/%m/%d`
72makedir $scriptlogpath
73
74scriptlog=$scriptlogpath/copyscript-$datetime.log
75
76date >> $scriptlog 2>&1
77
78# check if the script is already running
79date > $lockfile >> $scriptlog 2>&1
80checklock0=$?
81case $checklock0 in
82 0) echo "checklock0=$checklock0 -> continue " >> $scriptlog 2>&1;;
83 1) echo "checklock0=$checklock0 -> file exists " >> $scriptlog 2>&1
84 echo "-> copyscript is running -> exit" >> $scriptlog 2>&1
85 date >> $scriptlog 2>&1
86 exit;;
87 *) echo "checklock0=$checklock0 -> something went completely wrong" >> $scriptlog 2>&1;;
88esac
89
90cd $transdir
91
92#check the checksums, write output into file
93md5sum -c .checksums | tee $transdir/.check >> $scriptlog 2>&1
94
95if ! test -e $transdir/.check
96then
97 echo "couldn't create checkfile -> exit script" >> $scriptlog 2>&1
98 rm -v $lockfile >> $scriptlog 2>&1
99 date >> $scriptlog 2>&1
100 exit
101else
102 echo "checkfile created" >> $scriptlog 2>&1
103fi
104
105cd $mars
106
107echo "remove empty directories: " >> $scriptlog 2>&1
108rmdir -pv $transdir/*/* >> $scriptlog 2>&1
109
110#find all dates in transfer-directory
111#dates=`ls $transdir/*/ -1 | grep --regexp=20[0-9][0-9]_*[0-1][0-9]_*[0-3][0-9] | grep -v '.tgz'`
112dates=`ls $transdir/*/ -1 | grep --regexp=20[0-9][0-9]_[0-1][0-9]_[0-3][0-9] | grep -v '.tgz'` >> $scriptlog 2>&1
113if [ "$dates" = "" ]
114then
115 echo "nothing to do -> exit" >> $scriptlog 2>&1
116 rm -v $lockfile >> $scriptlog 2>&1
117 date >> $scriptlog 2>&1
118 exit
119fi
120
121echo "dates found: "$dates >> $scriptlog 2>&1
122#loop over dates
123for date in ${dates[@]}
124do
125 #find all files for this date
126 files=`find $transdir/*/$date/ -name "*.*"` >> $scriptlog 2>&1
127 if [ "$files" = "" ]
128 then
129 echo "no files found for $date" >> $scriptlog 2>&1
130 continue
131 else
132 echo "files found for $date" >> $scriptlog 2>&1
133 fi
134
135 date2=`echo $date | sed -e 's/_/\//g'`
136 copylogpath=$logpath/copyscript/$date2
137 echo "copylogpath: "$copylogpath >> $scriptlog 2>&1
138 makedir $copylogpath >> $scriptlog 2>&1
139
140 #loop over all files in the directories for this date
141 for file in $files
142 do
143 echo "file: "$file >> $scriptlog 2>&1
144 filename=`basename $file`
145
146 #check for each file whether it has to be processed
147 if grep "$filename: OK" $transdir/.check >> $scriptlog 2>&1
148 then
149 newfile=`echo $file | sed -e 's/home\/lapalma\/transfer/magic\/subsystemdata/' -e 's/ccdata/cc/' -e 's/cacodata/caco/' -e 's/drivelogs/drive/' -e 's/_/\//1' -e 's/_/\//1' `
150 echo "file (new path): "$newfile >> $scriptlog 2>&1
151 newpath=`dirname $newfile`
152 #make sure, that the needed directories are available
153 makedir $newpath >> $scriptlog 2>&1
154
155 #run macros if the file is a *.rbk or a *.run file to
156 #fill the information into the db
157 if echo $filename | grep .rbk >> $scriptlog 2>&1
158 then
159 echo "found rbk-file $filename" >> $scriptlog 2>&1
160 checkfillrbk=`root -q -b $macrospath/filldotrbk.C+\("\"$file\""\,kFALSE\) | tee $copylogpath/filldotrbk-$filename-log.txt | grep int | sed -e 's/(int)//'`
161 case $checkfillrbk in
162 1) echo "checkfillrbk=$checkfillrbk -> everything ok " >> $scriptlog 2>&1
163 echo " -> go on with copying file" >> $scriptlog 2>&1 ;;
164 *) echo "checkfillrbk=$checkfillrbk - Error -> go on with next file" >> $scriptlog 2>&1
165 continue;;
166 esac
167 fi
168 if echo $file | grep 'CC_.*.run' >> $scriptlog 2>&1 && ! echo $file | grep .run.html >> $scriptlog 2>&1
169 then
170 echo "found run-file $filename" >> $scriptlog 2>&1
171 checkfillrun=`root -q -b $macrospath/filldotrun.C+\("\"$file\""\,kFALSE\) | tee $copylogpath/filldotrun-$filename-log.txt | grep int | sed -e 's/(int)//'`
172 case $checkfillrun in
173 1) echo "checkfillrun=$checkfillrun -> everything ok " >> $scriptlog 2>&1
174 echo "-> insert date in SequenceBuildStatus for $date" >> $scriptlog 2>&1
175
176 checkinsertdate=`root -q -b $macrospath/insertdate.C+\("\"$date\""\) | tee $copylogpath/insertdate-$date-log.txt | grep int | sed -e 's/(int)//'`
177 case $checkinsertdate in
178 1) echo "date inserted" >> $scriptlog 2>&1 ;;
179 *) echo "checkinsertdate=$checkinsertdate -> ERROR - insert date didn't work" >> $scriptlog 2>&1
180 continue;;
181 esac
182 echo " -> go on with copying file" >> $scriptlog 2>&1 ;;
183 *) echo "checkfillrun=$checkfillrun Error -> go on with next file" >> $scriptlog 2>&1
184 continue;;
185 esac
186 fi
187
188 #copy file
189 totapefile=`echo $file | sed -e 's/home\/lapalma\/transfer/magic\/datacenter\/totape/'`
190 totapepath=`dirname $totapefile`
191 makedir $totapepath >> $scriptlog 2>&1
192 if ! cp -v $file $totapepath >> $scriptlog 2>&1
193 then
194 echo $file" couldn't be copied!!!!!" >> $scriptlog 2>&1
195 fi
196
197 if mv -v $file $newpath >> $scriptlog 2>&1
198 then
199 #add file to donelist
200 filename3=`echo $file | cut -c $char-999`
201 echo "$filename3 processed" >> $transdir/.processed
202 echo $filename" moved and added to .processed" >> $scriptlog 2>&1
203 else
204 echo $file" couldn't be moved!!!!!" >> $scriptlog 2>&1
205 fi
206
207 else
208 #if the checksum for the file is not ok or the file was
209 #already processed (entry in donelist) -> go on with next file
210 echo $file": checksum not ok " >> $scriptlog 2>&1
211 fi
212 done
213done
214
215echo "remove empty directories: " >> $scriptlog 2>&1
216rmdir -pv $transdir/*/* >> $scriptlog 2>&1
217
218rm -v $transdir/.check >> $scriptlog 2>&1
219
220
221
222#second part of the script:
223#update the catalog file magic_favorites.edb
224
225magfav=magic_favorites.edb #catalog filename
226catalog=$setuppath/$magfav #current catalogfile
227diff=$setuppath/.diff #file to store difference
228#addresses to which the changes are sent
229adrs="dorner@astro.uni-wuerzburg.de, tbretz@astro.uni-wuerzburg.de, hoehne@astro.uni-wuerzburg.de"
230
231#getting new catalogfiles
232catfiles=`find $subsystempath/cc/ -name $magfav -cnewer $catalog | sort`
233
234for catfile in ${catfiles[@]}
235do
236 #write information into .diff
237 echo "file: "$catfile >| $diff
238 diff $catalog $catfile >> $diff
239 #getting differences
240 ins=`cat $diff| grep '>'` #what has been inserted
241 outs=`cat $diff | grep '<'`#what has been removed
242
243 #check if lines have been inserted
244 if ! [ "$ins" == "" ]
245 then
246 echo "--> catalogfile: "$catfile >> $scriptlog 2>&1
247 echo "the following lines were added:" >> $scriptlog 2>&1
248 cat $diff | grep '>' >> $scriptlog 2>&1
249
250 #check if lines have been removed
251 if ! [ "$outs" == "" ]
252 then
253 echo "the following lines have been removed" >> $scriptlog 2>&1
254 cat $diff | grep '<' >> $scriptlog 2>&1
255 echo " -> please check the file $catfile" >> $scriptlog 2>&1
256 #inform $adr about removed lines
257 nail -s 'catalogfile - removed lines' $adrs < $diff
258 exit
259 fi
260
261 #getting date of new catalogfile from path
262 date=`echo $catfile | cut -d/ -f5-7 | sed -e 's/\///g'`
263
264 #rsync current catalogfile to directory with old catalogfiles including the date of the new catalogfile into the filename
265 if ! rsync -av $catalog $setuppath/oldcatalogs/$magfav.$date >> $scriptlog 2>&1
266 then
267 echo "could not do 'rsync -av $catalog $setuppath/oldcatalogs/$magfav.$date' -> exit" >> $scriptlog 2>&1
268 exit
269 fi
270 #rsync new catalogfile to current catalogfile
271 if ! rsync -av $catfile $catalog >> $scriptlog 2>&1
272 then
273 echo "could not do 'rsync -av $catfile $catalog' -> exit" >> $scriptlog 2>&1
274 exit
275 fi
276 #inform $adr about changes
277 echo "file has been rsynced sucessfully -> sending email" >> $scriptlog 2>&1
278 nail -s 'new catalogfile installed - new lines' $adrs < $diff
279 continue
280 fi
281 #check if lines have been removed
282 if ! [ "$outs" == "" ]
283 then
284 echo "the following lines have been removed" >> $scriptlog 2>&1
285 cat $diff | grep '<' >> $scriptlog 2>&1
286 echo " -> please check the file $catfile" >> $scriptlog 2>&1
287 #inform $adr about removed lines
288 nail -s 'catalogfile - removed lines' $adrs < $diff
289 exit
290 fi
291# echo "nothing has changed ($catfile)" >> $scriptlog 2>&1
292done
293
294
295rm -v $lockfile >> $scriptlog 2>&1
296date >> $scriptlog 2>&1
297
298set +C
Note: See TracBrowser for help on using the repository browser.